//+------------------------------------------------------------------+
//|                                                     .mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern   int      iTicket;             //   ()  
extern   int      iTrl_dist_1 = 20;    //    () (  MarketInfo(Symbol(),MODE_STOPLEVEL),  trl_dist_2  trl_dist_3);
extern   int      iLevel_1 = 25;       //   (),         trl_dist_1  trl_dist_2 ( level_2;  trl_dist_1);
extern   int      iTrl_dist_2 = 15;    //   ()       level_1  (  MarketInfo(Symbol(),MODE_STOPLEVEL));
extern   int      iLevel_2 = 35;       //   (),         trl_dist_2  trl_dist_3  ( trl_dist_1   level_1);
extern   int      iTrl_dist_3 = 10;    //   ()       level_2  (  MarketInfo(Symbol(),MODE_STOPLEVEL)).

extern double RiskPercentage = 1;     // 
extern int       TakeProfit = 500;
extern int       StopLoss = 500;
extern int    TrailingStop   = 50;     //  
extern int    MaxOrders      =  0;     //   ,  0 -  
extern int    BuyOp          = -100;     //   
extern int    SellOp         = 100;     //   
extern int    magicnumber    = 777;
extern int    CCI            = 14;     //  CCI
int expertBars;
extern int       _Sleep=5000;  
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



//---   
#include <>

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
   {
//----


   double margin = MarketInfo(Symbol(), MODE_MARGINREQUIRED);
   double minLot = MarketInfo(Symbol(), MODE_MINLOT);
   double maxLot = MarketInfo(Symbol(), MODE_MAXLOT);
   double step =   MarketInfo(Symbol(), MODE_LOTSTEP);
   double account = AccountFreeMargin();
   
   double percentage = account*RiskPercentage/100;
   
   double Lots = MathRound(percentage/margin/step)*step;
   
   if(Lots < minLot)
   {
      Lots = minLot;
   }
   
   if(Lots > maxLot)
   {
      Lots = maxLot;
   }
   
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
    
   
   
   int i=0;  
   int total = OrdersTotal();   
   for(i = 0; i <= total; i++) 
     {
      if(TrailingStop>0)  
       {                 
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if(OrderMagicNumber() == magicnumber) 
         {
         TrailingUdavka(OrderTicket(),iTrl_dist_1,iLevel_1,iTrl_dist_2,iLevel_2, iTrl_dist_3);
         }
       }
      }

   if ((total < MaxOrders || MaxOrders == 0)) 
     {
      if ((iCCI(NULL,0,CCI,PRICE_CLOSE,0) < BuyOp) && (iCCI(NULL,0,CCI,PRICE_CLOSE,0) > iCCI(NULL,0,CCI,PRICE_CLOSE,1)))
       {
        if (Open[0]>Open[1])
          {OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-StopLoss*Point,Ask+TakeProfit*Point,"CCI_Buy",magicnumber,0,Green);}Sleep(5000); //   10 
       }
      if ((iCCI(NULL,0,CCI,PRICE_CLOSE,0) > SellOp) && (iCCI(NULL,0,CCI,PRICE_CLOSE,0) < iCCI(NULL,0,CCI,PRICE_CLOSE,1)))
       {
        if (Open[0]<Open[1])
          {OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+StopLoss*Point,Bid-TakeProfit*Point,"CCI_Sell",magicnumber,0,Red);}Sleep(5000); //   10 
       } 
     } 
//----
   return(0);
  }
 
//+------------------------------------------------------------------+

void TrailingUdavka(int ticket,int trl_dist_1,int level_1,int trl_dist_2,int level_2,int trl_dist_3)
   {  
   
   double newstop = 0; //  
   double trldist; //   (   ""  = trl_dist_1, trl_dist_2  trl_dist_3)

   //   
   if ((trl_dist_1<MarketInfo(Symbol(),MODE_STOPLEVEL)) || (trl_dist_2<MarketInfo(Symbol(),MODE_STOPLEVEL)) || (trl_dist_3<MarketInfo(Symbol(),MODE_STOPLEVEL)) || 
   (level_1<=trl_dist_1) || (level_2<=trl_dist_1) || (level_2<=level_1) || (ticket==0) || (!OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)))
      {
      } 
   
   //    (OP_BUY)
   if (OrderType()==OP_BUY)
      {
      //   <=trl_dist_1,  trldist=trl_dist_1,  >trl_dist_1 && <=level_1*Point ...
      if ((Bid-OrderOpenPrice())<=level_1*Point) trldist = trl_dist_1;
      if (((Bid-OrderOpenPrice())>level_1*Point) && ((Bid-OrderOpenPrice())<=level_2*Point)) trldist = trl_dist_2;
      if ((Bid-OrderOpenPrice())>level_2*Point) trldist = trl_dist_3; 
            
      //   = 0    ,   . (Bid) /  _+.
      if ((OrderStopLoss()==0) || (OrderStopLoss()<OrderOpenPrice()))
         {
         if (Bid>(OrderOpenPrice() + trldist*Point))
         newstop = Bid -  trldist*Point;
         }

      // :    (Bid) /  _+ , 
      else
         {
         if (Bid>(OrderStopLoss() + trldist*Point))
         newstop = Bid -  trldist*Point;
         }
      
      //  
      if ((newstop>OrderStopLoss()) && (newstop<Bid-MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
         {
         if (!OrderModify(ticket,OrderOpenPrice(),newstop,OrderTakeProfit(),OrderExpiration()))
         Print("     ",OrderTicket(),". : ",GetLastError());
         }
      }
      
   //    (OP_SELL)
   if (OrderType()==OP_SELL)
      { 
      //   <=trl_dist_1,  trldist=trl_dist_1,  >trl_dist_1 && <=level_1*Point ...
      if ((OrderOpenPrice()-(Ask + MarketInfo(Symbol(),MODE_SPREAD)*Point))<=level_1*Point) trldist = trl_dist_1;
      if (((OrderOpenPrice()-(Ask + MarketInfo(Symbol(),MODE_SPREAD)*Point))>level_1*Point) && ((OrderOpenPrice()-(Ask + MarketInfo(Symbol(),MODE_SPREAD)*Point))<=level_2*Point)) trldist = trl_dist_2;
      if ((OrderOpenPrice()-(Ask + MarketInfo(Symbol(),MODE_SPREAD)*Point))>level_2*Point) trldist = trl_dist_3; 
            
      //   = 0    ,   . (Ask) /  _+.
      if ((OrderStopLoss()==0) || (OrderStopLoss()>OrderOpenPrice()))
         {
         if (Ask<(OrderOpenPrice() - (trldist + MarketInfo(Symbol(),MODE_SPREAD))*Point))
         newstop = Ask + trldist*Point;
         }

      // :    (Bid) /  _+ , 
      else
         {
         if (Ask<(OrderStopLoss() - (trldist + MarketInfo(Symbol(),MODE_SPREAD))*Point))
         newstop = Ask +  trldist*Point;
         }
            
       //  
      if (newstop>0)
         {
         if (((OrderStopLoss()==0) || (OrderStopLoss()>OrderOpenPrice())) && (newstop>Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
            {
            if (!OrderModify(ticket,OrderOpenPrice(),newstop,OrderTakeProfit(),OrderExpiration()))
            Print("     ",OrderTicket(),". : ",GetLastError());
            }
         else
            {
            if ((newstop<OrderStopLoss()) && (newstop>Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))  
               {
               if (!OrderModify(ticket,OrderOpenPrice(),newstop,OrderTakeProfit(),OrderExpiration()))
               Print("     ",OrderTicket(),". : ",GetLastError());
               }
            }
         }
      }      
   }
//+------------------------------------------------------------------+